From f4a6ca8c7710a9224ca982c53c8756160e90159c Mon Sep 17 00:00:00 2001
From: Metztli Information Technology <jose@metztli.it>
Date: Tue, 15 Oct 2019 06:25:18 -0700
Subject: [PATCH] Enhancing Debian packaging for php7.3_7.3.10-1 to generate
 ZTS and pthreads versions for CLI

---
 changelog                                  |     2 +-
 control                                    |   169 +-
 copyright                                  |    67 +
 patches/metztli/metztli-ext-pthreads.patch | 18954 +++++++++++++++++++
 patches/series                             |     1 +
 rules                                      |     1 +
 rules.d/pthreads.mk                        |    10 +
 7 files changed, 19130 insertions(+), 74 deletions(-)
 create mode 100644 patches/metztli/metztli-ext-pthreads.patch
 create mode 100644 rules.d/pthreads.mk

diff --git a/changelog b/changelog
index f52e44b..e0a8075 100644
--- a/changelog
+++ b/changelog
@@ -1,4 +1,4 @@
-php7.3 (7.3.10-1) unstable; urgency=medium
+php7.3-zts (7.3.10-1) unstable; urgency=medium
 
   * New upstream version 7.3.10
 
diff --git a/control b/control
index 1b5be85..b6f187f 100644
--- a/control
+++ b/control
@@ -1,4 +1,4 @@
-Source: php7.3
+Source: php7.3-zts
 Section: php
 Priority: optional
 Maintainer: Debian PHP Maintainers <team+pkg-php@tracker.debian.org>
@@ -80,15 +80,15 @@ Vcs-Git: https://salsa.debian.org/php-team/php.git -b master-7.3
 Vcs-Browser: https://salsa.debian.org/php-team/php
 Homepage: http://www.php.net/
 
-Package: libapache2-mod-php7.3
+Package: libapache2-mod-php7.3-zts
 Section: httpd
 Architecture: any
 Depends: libmagic1,
          mime-support,
-         php7.3-cli,
-         php7.3-common (= ${binary:Version}),
-         php7.3-json,
-         php7.3-opcache,
+         php7.3-zts-cli,
+         php7.3-zts-common (= ${binary:Version}),
+         php7.3-zts-json,
+         php7.3-zts-opcache,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -108,14 +108,14 @@ Description: server-side, HTML-embedded scripting language (Apache 2 module)
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: libphp7.3-embed
+Package: libphp7.3-zts-embed
 Architecture: any
 Depends: libmagic1,
          mime-support,
-         php7.3-cli,
-         php7.3-common (= ${binary:Version}),
-         php7.3-json,
-         php7.3-opcache,
+         php7.3-zts-cli,
+         php7.3-zts-common (= ${binary:Version}),
+         php7.3-zts-json,
+         php7.3-zts-opcache,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -124,7 +124,7 @@ Provides: libphp-embed,
           ${php:Provides}
 Suggests: php-pear
 Description: HTML-embedded scripting language (Embedded SAPI library)
- This package provides the library /usr/lib/libphp7.3.so which can
+ This package provides the library /usr/lib/libphp7.3-zts.so which can
  be used by application developers to embed PHP scripting functionality.
  .
  ${php:Extensions}
@@ -137,10 +137,10 @@ Description: HTML-embedded scripting language (Embedded SAPI library)
  the API/ABI will be kept compatible even between minor releases.  You
  have been warned.
 
-Package: php7.3
+Package: php7.3-zts
 Architecture: all
-Depends: libapache2-mod-php7.3 | php7.3-fpm | php7.3-cgi,
-         php7.3-common,
+Depends: libapache2-mod-php7.3-zts | php7.3-zts-fpm | php7.3-zts-cgi,
+         php7.3-zts-common,
          ${misc:Depends}
 Provides: php
 Description: server-side, HTML-embedded scripting language (metapackage)
@@ -153,14 +153,14 @@ Description: server-side, HTML-embedded scripting language (metapackage)
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-cgi
+Package: php7.3-zts-cgi
 Architecture: any
 Depends: libmagic1,
          mime-support,
-         php7.3-cli,
-         php7.3-common (= ${binary:Version}),
-         php7.3-json,
-         php7.3-opcache,
+         php7.3-zts-cli,
+         php7.3-zts-common (= ${binary:Version}),
+         php7.3-zts-json,
+         php7.3-zts-opcache,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -172,7 +172,7 @@ Description: server-side, HTML-embedded scripting language (CGI binary)
  This package provides the /usr/lib/cgi-bin/php CGI interpreter built
  for use in Apache 2 with mod_actions, or any other CGI httpd that
  supports a similar mechanism.  Note that MOST users probably
- want the php7.3-fpm package.
+ want the php7.3-zts-fpm package.
  .
  ${php:Extensions}
  .
@@ -180,15 +180,15 @@ Description: server-side, HTML-embedded scripting language (CGI binary)
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-cli
+Package: php7.3-zts-cli
 Architecture: any
 Depends: libedit2 (>= 2.11-20080614-4),
          libmagic1,
          mime-support,
-         php7.3-common (= ${binary:Version}),
-         php7.3-json,
-         php7.3-opcache,
-         php7.3-readline,
+         php7.3-zts-common (= ${binary:Version}),
+         php7.3-zts-json,
+         php7.3-zts-opcache,
+         php7.3-zts-readline,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -197,7 +197,7 @@ Provides: php-cli,
           ${php:Provides}
 Suggests: php-pear
 Description: command-line interpreter for the PHP scripting language
- This package provides the /usr/bin/php7.3 command interpreter, useful for
+ This package provides the /usr/bin/php7.3-zts command interpreter, useful for
  testing PHP scripts from a shell or performing general shell scripting tasks.
  .
  ${php:Extensions}
@@ -206,13 +206,13 @@ Description: command-line interpreter for the PHP scripting language
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-dev
+Package: php7.3-zts-dev
 Depends: autoconf (>= 2.63),
          automake (>= 1.11),
 	 libpcre2-dev (>= 10.30),
          libssl-dev,
-         php7.3-cli (>= ${binary:Version}),
-         php7.3-common (= ${binary:Version}),
+         php7.3-zts-cli (>= ${binary:Version}),
+         php7.3-zts-common (= ${binary:Version}),
          shtool,
          ${libtool:Depends},
          ${misc:Depends},
@@ -229,14 +229,14 @@ Description: Files for PHP7.3 module development
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-fpm
+Package: php7.3-zts-fpm
 Architecture: any
 Depends: libmagic1,
          mime-support,
-         php7.3-cli,
-         php7.3-common (= ${binary:Version}),
-         php7.3-json,
-         php7.3-opcache,
+         php7.3-zts-cli,
+         php7.3-zts-common (= ${binary:Version}),
+         php7.3-zts-json,
+         php7.3-zts-opcache,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -248,7 +248,7 @@ Pre-Depends: ${misc:Pre-Depends}
 Description: server-side, HTML-embedded scripting language (FPM-CGI binary)
  This package provides the Fast Process Manager interpreter that runs
  as a daemon and receives Fast/CGI requests.  Note that MOST Apache users
- probably want the libapache2-mod-php7.3 package.
+ probably want the libapache2-mod-php7.3-zts package.
  .
  ${php:Extensions}
  .
@@ -256,14 +256,14 @@ Description: server-side, HTML-embedded scripting language (FPM-CGI binary)
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-phpdbg
+Package: php7.3-zts-phpdbg
 Architecture: any
 Depends: libmagic1,
          mime-support,
-         php7.3-cli,
-         php7.3-common (= ${binary:Version}),
-         php7.3-json,
-         php7.3-opcache,
+         php7.3-zts-cli,
+         php7.3-zts-common (= ${binary:Version}),
+         php7.3-zts-json,
+         php7.3-zts-opcache,
          tzdata,
          ucf,
          ${misc:Depends},
@@ -281,16 +281,16 @@ Description: server-side, HTML-embedded scripting language (PHPDBG binary)
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-xsl
+Package: php7.3-zts-xsl
 Architecture: all
-Depends: php7.3-common,
-         php7.3-xml,
+Depends: php7.3-zts-common,
+         php7.3-zts-xml,
          ${misc:Depends}
 Description: XSL module for PHP (dummy)
  This package is a transitional dummy package and can be safely
  removed.
 
-Package: php7.3-odbc
+Package: php7.3-zts-odbc
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -313,7 +313,30 @@ Description: ODBC module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-readline
+Package: php7.3-zts-pthreads
+Architecture: any
+Depends: php-common (>= 1:35),
+         ucf,
+         ${misc:Depends},
+         ${php:Depends},
+         ${php-pthreads:Depends},
+         ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends},
+             ${php-pthreads:Pre-Depends}
+Built-Using: ${php:Built-Using}
+Replaces: ${php-pthreads:Replaces}
+Breaks: ${php-pthreads:Breaks}
+Conflicts: ${php-pthreads:Conflicts}
+Provides: ${php-pthreads:Provides}
+Recommends: ${php-pthreads:Recommends}
+Description: KrakJoe pthreads module for PHP
+ This package provides the KrakJoe pthreads module(s) for PHP.
+ .
+ PHP (recursive acronym for PHP: Hypertext Preprocessor) is a widely-used
+ open source general-purpose scripting language that is especially suited
+ for web development and can be embedded into HTML.
+
+Package: php7.3-zts-readline
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -336,7 +359,7 @@ Description: readline module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-recode
+Package: php7.3-zts-recode
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -359,7 +382,7 @@ Description: recode module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-sqlite3
+Package: php7.3-zts-sqlite3
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -382,7 +405,7 @@ Description: SQLite3 module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-tidy
+Package: php7.3-zts-tidy
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -405,7 +428,7 @@ Description: tidy module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-xml
+Package: php7.3-zts-xml
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -428,7 +451,7 @@ Description: DOM, SimpleXML, WDDX, XML, and XSL module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-sybase
+Package: php7.3-zts-sybase
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -451,7 +474,7 @@ Description: Sybase module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-gd
+Package: php7.3-zts-gd
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -474,7 +497,7 @@ Description: GD module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-gmp
+Package: php7.3-zts-gmp
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -497,7 +520,7 @@ Description: GMP module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-zip
+Package: php7.3-zts-zip
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -520,7 +543,7 @@ Description: Zip module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-common
+Package: php7.3-zts-common
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -543,7 +566,7 @@ Description: documentation, examples and common module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-intl
+Package: php7.3-zts-intl
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -566,7 +589,7 @@ Description: Internationalisation module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-snmp
+Package: php7.3-zts-snmp
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -589,7 +612,7 @@ Description: SNMP module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-curl
+Package: php7.3-zts-curl
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -612,7 +635,7 @@ Description: CURL module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-json
+Package: php7.3-zts-json
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -635,7 +658,7 @@ Description: JSON module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-pgsql
+Package: php7.3-zts-pgsql
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -658,7 +681,7 @@ Description: PostgreSQL module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-mbstring
+Package: php7.3-zts-mbstring
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -681,7 +704,7 @@ Description: MBSTRING module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-enchant
+Package: php7.3-zts-enchant
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -704,7 +727,7 @@ Description: Enchant module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-opcache
+Package: php7.3-zts-opcache
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -727,7 +750,7 @@ Description: Zend OpCache module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-imap
+Package: php7.3-zts-imap
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -750,7 +773,7 @@ Description: IMAP module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-mysql
+Package: php7.3-zts-mysql
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -773,7 +796,7 @@ Description: MySQL module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-bcmath
+Package: php7.3-zts-bcmath
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -796,7 +819,7 @@ Description: Bcmath module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-soap
+Package: php7.3-zts-soap
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -819,7 +842,7 @@ Description: SOAP module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-dba
+Package: php7.3-zts-dba
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -842,7 +865,7 @@ Description: DBA module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-interbase
+Package: php7.3-zts-interbase
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -865,7 +888,7 @@ Description: Interbase module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-xmlrpc
+Package: php7.3-zts-xmlrpc
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -888,7 +911,7 @@ Description: XMLRPC-EPI module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-pspell
+Package: php7.3-zts-pspell
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -911,7 +934,7 @@ Description: pspell module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-bz2
+Package: php7.3-zts-bz2
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
@@ -934,7 +957,7 @@ Description: bzip2 module for PHP
  open source general-purpose scripting language that is especially suited
  for web development and can be embedded into HTML.
 
-Package: php7.3-ldap
+Package: php7.3-zts-ldap
 Architecture: any
 Depends: php-common (>= 1:35),
          ucf,
diff --git a/copyright b/copyright
index 775b6a7..1df0c33 100644
--- a/copyright
+++ b/copyright
@@ -738,3 +738,70 @@ License: BSD-4-clause
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.
+
+License: pthreads
+-------------------------------------------------------------------- 
+                  The PHP License, version 3.01
+Copyright (c) 2012-2014 Joe Watkins. All rights reserved.
+-------------------------------------------------------------------- 
+
+Redistribution and use in source and binary forms, with or without
+modification, is permitted provided that the following conditions
+are met:
+
+  1. Redistributions of source code must retain the above copyright
+     notice, this list of conditions and the following disclaimer.
+ 
+  2. Redistributions in binary form must reproduce the above copyright
+     notice, this list of conditions and the following disclaimer in
+     the documentation and/or other materials provided with the
+     distribution.
+ 
+  3. The name "PHP" must not be used to endorse or promote products
+     derived from this software without prior written permission. For
+     written permission, please contact group@php.net.
+  
+  4. Products derived from this software may not be called "PHP", nor
+     may "PHP" appear in their name, without prior written permission
+     from group@php.net.  You may indicate that your software works in
+     conjunction with PHP by saying "Foo for PHP" instead of calling
+     it "PHP Foo" or "phpfoo"
+ 
+  5. The PHP Group may publish revised and/or new versions of the
+     license from time to time. Each version will be given a
+     distinguishing version number.
+     Once covered code has been published under a particular version
+     of the license, you may always continue to use it under the terms
+     of that version. You may also choose to use such covered code
+     under the terms of any subsequent version of the license
+     published by the PHP Group. No one other than the PHP Group has
+     the right to modify the terms applicable to covered code created
+     under this License.
+
+  6. Redistributions of any form whatsoever must retain the following
+     acknowledgment:
+     "This product includes PHP software, freely available from
+     <http://www.php.net/software/>".
+
+THIS SOFTWARE IS PROVIDED BY THE PHP DEVELOPMENT TEAM ``AS IS'' AND 
+ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
+PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE PHP
+DEVELOPMENT TEAM OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
+INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
+(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
+SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
+OF THE POSSIBILITY OF SUCH DAMAGE.
+
+-------------------------------------------------------------------- 
+
+The PHP Group can be contacted via Email at group@php.net.
+
+For more information on the PHP Group and the PHP project, 
+please see <http://www.php.net>.
+
+PHP includes the Zend Engine, freely available at
+<http://www.zend.com>.
diff --git a/patches/series b/patches/series
index 424cb2d..02ab97a 100644
--- a/patches/series
+++ b/patches/series
@@ -46,3 +46,4 @@
 0046-Fix-ext-date-lib-parse_tz-PATH_MAX-HURD-FTBFS.patch
 0047-Use-pkg-config-for-FreeType2-detection.patch
 0048-Amend-C-11-for-intl-compilation-on-older-distributio.patch
+metztli/metztli-ext-pthreads.patch
diff --git a/rules b/rules
index ce87af8..03bda7e 100755
--- a/rules
+++ b/rules
@@ -524,6 +524,7 @@ override_dh_install-arch: remove-files-stamp prepare-fpm-pools
 	cat php.ini-production | tr "\t" " " | \
 	$(SED) -e'/memory_limit =/ s/128M/-1/g;' \
 	    -e'/session.gc_probability =/ s/1/0/g' \
+	    -e'937i;Metztli IT added required cli directive:\nextension=pthreads' \
 	  > debian/$(PHP_COMMON)/usr/lib/php/$(PHP_NAME_VERSION)/php.ini-production.cli
 
 	cat php.ini-development | tr "\t" " " | \
diff --git a/rules.d/pthreads.mk b/rules.d/pthreads.mk
new file mode 100644
index 0000000..1540311
--- /dev/null
+++ b/rules.d/pthreads.mk
@@ -0,0 +1,10 @@
+ext_PACKAGES      += pthreads
+pthreads_DESCRIPTION := KrakJoe pthreads
+pthreads_EXTENSIONS  := pthreads
+pthreads_PRIORITY    := 10
+pthreads_EXTENSION   := krakjoe_extension
+pthreads_config      := --enable-pthreads=shared,/usr
+export pthreads_EXTENSIONS
+export pthreads_DESCRIPTION
+export pthreads_PRIORITY
+export pthreads_EXTENSION
-- 
2.20.1

